/*
    Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015
    Ben Kibbey <bjk@luxsci.net>

    This file is part of pwmd.

    Pwmd is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Pwmd is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Pwmd.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CIPHER_H
#define CIPHER_H

#include <stdint.h>

#define PWMD_CIPHER_OFFSET	(1)
#define PWMD_CIPHER(n)		(PWMD_CIPHER_OFFSET << n)
#define PWMD_CIPHER_AES128	PWMD_CIPHER (0)
#define PWMD_CIPHER_AES192	PWMD_CIPHER (1)
#define PWMD_CIPHER_AES256	PWMD_CIPHER (2)
#define PWMD_CIPHER_SERPENT128	PWMD_CIPHER (3)
#define PWMD_CIPHER_SERPENT192	PWMD_CIPHER (4)
#define PWMD_CIPHER_SERPENT256	PWMD_CIPHER (5)
#define PWMD_CIPHER_CAMELLIA128	PWMD_CIPHER (6)
#define PWMD_CIPHER_CAMELLIA192	PWMD_CIPHER (7)
#define PWMD_CIPHER_CAMELLIA256	PWMD_CIPHER (8)
#define PWMD_CIPHER_3DES	PWMD_CIPHER (9)
#define PWMD_CIPHER_CAST5	PWMD_CIPHER (10)
#define PWMD_CIPHER_BLOWFISH	PWMD_CIPHER (11)
#define PWMD_CIPHER_TWOFISH	PWMD_CIPHER (12)
#define PWMD_CIPHER_TWOFISH128	PWMD_CIPHER (13)

#define PWMD_FLAG_OFFSET	(PWMD_CIPHER_OFFSET << 15)
#define PWMD_FLAG(n)		(PWMD_FLAG_OFFSET << n)
#define PWMD_FLAG_PKI           PWMD_FLAG (1)
#define PWMD_FLAG_NO_PASSPHRASE PWMD_FLAG (2)

int cipher_string_to_gcrypt (const char *str);
int cipher_to_gcrypt (int flags);
unsigned gcrypt_to_cipher (int n);
int cipher_string_to_cipher (const char *str);
uint64_t set_cipher_flag (uint64_t flags, int algo);

#endif
