/*
    Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015
    Ben Kibbey <bjk@luxsci.net>

    This file is part of pwmd.

    Pwmd is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Pwmd is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Pwmd.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef COMMANDS_H
#define COMMANDS_H

/* Flags needed to be retained for a client across commands. */
#define FLAG_NEW		0x0001
#define FLAG_HAS_LOCK		0x0002
#define FLAG_LOCK_CMD		0x0004
#define FLAG_NO_PINENTRY	0x0008
#define FLAG_OPEN		0x0010
#define FLAG_KEEP_LOCK		0x0020
#define FLAG_ACL_IGNORE		0x0040 // ATTR LIST
#define FLAG_ACL_ERROR		0x0080 // ...

gpg_error_t register_commands (assuan_context_t ctx);
int valid_filename (const char *filename);
void cleanup_client (struct client_s *client);
void init_commands ();
void deinit_commands ();

#endif
