/*
    Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015
    Ben Kibbey <bjk@luxsci.net>

    This file is part of pwmd.

    Pwmd is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Pwmd is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Pwmd.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MEM_H
#define MEM_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <sys/types.h>
#include <stdarg.h>

#ifdef MEM_DEBUG
#include <stdlib.h>
#define xfree free
#define xmalloc malloc
#define xrealloc realloc
#define xcalloc calloc
#else
  void xmem_init (void) __attribute__ ((visibility ("hidden")));
  void xfree (void *ptr) __attribute__ ((visibility ("hidden")));
  void *xmalloc (size_t size) __attribute__ ((visibility ("hidden")));
  void *xrealloc (void *ptr, size_t size)
    __attribute__ ((visibility ("hidden")));
  void *xcalloc (size_t nmemb, size_t size)
    __attribute__ ((visibility ("hidden")));
  void xpanic (void) __attribute__ ((visibility ("hidden")));
#ifdef DEBUG
  void xdump (void) __attribute__ ((visibility ("hidden")));
#endif
#endif

#ifdef __cplusplus
}
#endif

#endif
