/*
    Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015
    Ben Kibbey <bjk@luxsci.net>

    This file is part of pwmd.

    Pwmd is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Pwmd is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Pwmd.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef STATUS_H
#define STATUS_H

#include <gpg-error.h>
#include <assuan.h>

typedef enum
{
  STATUS_CACHE,
  STATUS_CLIENTS,
  STATUS_LOCKED,
  STATUS_ENCRYPT,
  STATUS_DECRYPT,
  STATUS_XFER,
  STATUS_GENKEY,
  STATUS_NEWFILE,
  STATUS_AGENT,
  STATUS_KEEPALIVE,
  STATUS_STATE,
} status_msg_t;

struct status_msg_s
{
  status_msg_t s;
  char *line;
  struct status_msg_s *next;
};

gpg_error_t send_status (assuan_context_t ctx, status_msg_t which,
			 const char *fmt, ...);
void send_status_all (status_msg_t s, const char *fmt, ...);
void send_status_all_not_self (int, status_msg_t s, const char *fmt, ...);

#endif
